<HTML>
<HEAD>
  <META NAME="GENERATOR" CONTENT="Adobe PageMill 3.0 Win">
  <TITLE>Ambient Compiler Type Inference</TITLE>
</HEAD>
<BODY BGCOLOR="#ffffff">

<H2>CS237c: Ambient Compiler</H2>

<H2>Type inference</H2>

<P>The result of type inference is just an explicitly-typed version
of the source language. All types and module types are &quot;lifted&quot;
to the top-level and saved in a type environment. <I>Module types</I>
are coded as tables.</P>

<BLOCKQUOTE>
  <PRE><I>(*</I>
<I> * Types.</I>
<I> *)</I>
<B>type</B> ty =
   TyInt of loc
 | TyChar of loc
 | TyString of loc
 | TyFun of ty * ty * loc
 | TyProd of ty list * loc
 | TyRecord of (bool * label_var * ty) list * loc
 | TyUnion of (const_var * ty list) list * loc
 | TyArray of ty * loc
 | TyApply of ty_var * ty list * loc
   <I>(*</I>
<I>    * Varables.</I>
<I>    * TyParam are type variables.</I>
<I>    * TyAbstract is used to define abstract types.</I>
<I>    *)</I>
 | TyAbstract of loc
 | TyParam of param_var * loc
 | TyAll of param_var list * ty * loc
   (* Ambients *)
 | TyOpen of (var * ty) list * param_var * loc

<I>(*</I>
<I> * Patterns.</I>
<I> *)</I>
and patt =
   PattInt of int * loc
 | PattChar of char * loc
 | PattString of string * loc
 | PattWild of ty * loc
 | PattVar of var * ty * loc
 | PattTuple of patt list * ty * loc
 | PattRecord of (label_var * patt) list * ty * loc
 | PattArray of patt list * ty * loc
 | PattConst of const_var * patt list * ty * loc
 | PattChoice of patt * patt * ty * loc
 | PattAs of patt * patt * ty * loc

<I>(*</I>
<I> * Static expressions.</I>
<I> *)</I>
and exp =
   <I>(* Lambda calculus *)</I>
   Number of int * loc
 | Char of char * loc
 | String of string * loc
 | Var of var_name * ty * loc
 | Const of const_var * ty * loc
 | Unop of unop * exp * ty * loc
 | Binop of binop * exp * exp * ty * loc
 | Apply of exp * exp list * ty * loc
 | Lambda of patt list * exp * ty * loc
 | Function of guarded * ty * loc
 | Let of lets * exp * ty * loc
 | Funs of funs * exp * ty * loc
 | If of exp * exp * exp * ty * loc

   <I>(* Aggregates *)</I>
 | Tuple of exp list * ty * loc
 | Array of exp list * ty * loc
 | ArraySubscript of exp * exp * ty * loc
 | ArrayAssign of exp * exp * exp * loc
 | StringSubscript of exp * exp * loc
 | StringAssign of exp * exp * exp * loc
 | Record of record_item list * ty * loc
 | RecordProj of exp * label_var * ty * loc
 | RecordAssign of exp * label_var * exp * loc

   <I>(* Statement composition *)</I>
 | Sequence of exp * exp * ty * loc

   <I>(* Control flow *)</I>
 | Match of exp * guarded * ty * loc
 | Try of exp * guarded * ty * loc
 | CallCC of var * exp * ty * loc

   <I>(* Ambient calculus *)</I>
 | In of mod_name * ty * loc
 | Out of mod_name * ty * loc
 | Open of mod_name * ty * loc
 | Action of exp list * ty * loc
 | Restrict of me_var * mt_var * exp * ty * loc
 | Ambient of me_var * module_exp * loc
 | Thread of exp * loc
 | Migrate of exp * exp * ty * loc
 | LetModule of me_var * module_exp * exp * ty * loc

<I>(* Info for a record creation *)</I>
<B>and</B> record_item = label_var * exp * loc

<I>(* Variable definitions *)</I>
<B>and</B> lets = (patt * exp * ty) list

<I>(* Function definitions *)</I>
<B>and</B> funs = (var * patt list * exp * ty) list

<I>(* Type definitions *)</I>
<B>and</B> types = ty_var list

<I>(* Guarded commands *)</I>
<B>and</B> guarded = (patt * exp) list

<I>(*</I>
<I> * In a module expression, each item has an internal and</I>
<I> * an external name.  For lets, funs, and types, the map</I>
<I> * between internal and external is given through a substitution.</I>
<I> * For the others, both variable names are given.</I>
<I> *)</I>
<B>and</B> var_subst = (ext_var * var) list
<B>and</B> ty_subst = (ext_var * ty_var) list

<B>and</B> module_field =
   FieldLet of lets * var_subst * loc
 | FieldFuns of funs * var_subst * loc
 | FieldType of ty_subst * loc
 | FieldExpr of exp * loc
 | FieldRestrict of ext_var * me_var * mt_var * loc
 | FieldModule of ext_var * me_var * module_exp * mt_var * loc
 | FieldModuleType of ext_var * mt_var * loc

<B>and</B> module_exp =
   ModuleExpStruct of module_field list * mt_var * loc
 | ModuleExpVar of mod_name * mt_var * loc
 | ModuleExpConstrain of module_exp * mt_var * loc

<I>(*</I>
<I> * Exceptions.</I>
<I> *)</I>
<B>type</B> type_error =
   ExtUnboundVar of ext_var * loc
 | ExtUnboundConst of ext_var * loc
 | ExtUnboundLabel of ext_var * loc
 | ExtUnboundType of ext_var * loc
 | ExtUnboundModule of ext_var * loc
 | ExtUnboundModuleType of ext_var * loc
 | ExtUnboundParam of ext_var * loc
 | ExtMultipleBinding of ext_var * loc
 | NestedRecordType of Ast.ty
 | NestedUnionType of Ast.ty
 | TypeMismatch of ty * ty
 | ArityMismatch of ty_var * int * int * loc
 | RecordMismatch of ty_var * ty_var * loc
 | ChoiceBinding of patt * loc

<B>exception</B> TypeError <B>of</B> type_error</PRE>
</BLOCKQUOTE>

</BODY>
</HTML>
